/*!
 *     jquery-ajax-cache -- Ajax Cache plugin backed by localStorage or sessionStorage for jQuery
 *     Version 2.0.0
 *     https://github.com/WQTeam/jquery-ajax-cache
 *     (c) 2013-2015 WQTeam, MIT license
 * 
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.$ajaxCache=t():e.$ajaxCache=t()}(this,function(){return function(e){function t(n){if(r[n])return r[n].exports;var o=r[n]={exports:{},id:n,loaded:!1};return e[n].call(o.exports,o,o.exports,t),o.loaded=!0,o.exports}var r={};return t.m=e,t.c=r,t.p="",t(0)}([function(e,t,r){"use strict";var n=r(1);e.exports=new n.AjaxCache},function(e,t,r){"use strict";function n(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var o=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}();Object.defineProperty(t,"__esModule",{value:!0}),t.AjaxCache=void 0;var a=r(2),i=r(4);t.AjaxCache=function(){function e(){n(this,e)}return o(e,[{key:"config",value:function(){var e=arguments.length<=0||void 0===arguments[0]?{}:arguments[0];return this.cacheProxy=new a.CacheProxy(e),this.$=e.$||window.$,null==this.$?void console.error("AjaxCache Config Fail!!! can not find jQuery in `global` or `options`!!"):void(0,i.addFilterToJquery)(this)}},{key:"getCacheProxy",value:function(){return this.cacheProxy}},{key:"deleteAllExpires",value:function(){this.cacheProxy.deleteAllExpires()}}]),e}()},function(e,t,r){"use strict";function n(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function o(e,t){for(var r in t)e[r]=t[r];return e}var a=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}();Object.defineProperty(t,"__esModule",{value:!0}),t.CacheProxy=void 0;var i=r(3),c=r(6),u=r(5);t.CacheProxy=function(){function e(t){n(this,e);var r={timeout:i.defaultTimeout,storageType:i.defaultStorageType,cacheValidate:i.defaultCacheValidate,preGenCacheKey:i.defaultPreGenCacheKey,forceRefresh:!1},a=o(r,t);this.defaultTimeout=a.timeout,this.storageType=a.storageType,this.cacheValidate=a.cacheValidate,this.preGenCacheKey=a.preGenCacheKey,this.forceRefresh=a.forceRefresh,this.storageMap={sessionStorage:new c({storage:"sessionStorage"}),localStorage:new c({storage:"localStorage"})},this.deleteAllExpires()}return a(e,[{key:"genCacheKey",value:function(e,t,r){var n=this.preGenCacheKey;return"function"==typeof r&&(n=r),u(n(e,t))}},{key:"getStorage",value:function(e){return this.storageMap[e]||this.storageMap[this.storageType]||this.storageMap.localStorage}},{key:"getCacheValidateFun",value:function(){return this.cacheValidate}},{key:"deleteAllExpires",value:function(){this.storageMap.sessionStorage.deleteAllExpires(),this.storageMap.localStorage.deleteAllExpires()}}]),e}()},function(e,t){"use strict";function r(e){return console.warn("There is no cacheValidate function!!"),!1}function n(e,t){var r,n,o=t.data||{};try{"string"!=typeof n&&(n=JSON.stringify(o)),r=t.url.replace(/jQuery.*/,"")+e.type.toUpperCase()+(n||"")}catch(a){console.error(a)}return r}Object.defineProperty(t,"__esModule",{value:!0}),t.defaultCacheValidate=r,t.defaultPreGenCacheKey=n;t.defaultTimeout=3600,t.defaultStorageType="localStorage"},function(e,t){"use strict";function r(e){var t=e.$;t.ajaxPrefilter(function(t,r,n){var o=e.getCacheProxy(),a=t.ajaxCache;if(a){var i=o.getStorage(a.storageType);if(i.isSupported())try{var c=o.genCacheKey(t,r,a.preGenCacheKey),u=i.get(c);if(a.forceRefresh===!0&&(i["delete"](c),u=null),!u){var s;t.success&&(s=t.success),t.success=function(e){var r=o.defaultTimeout;"number"==typeof a.timeout&&(r=a.timeout);try{var n=a.cacheValidate||o.getCacheValidateFun();"function"==typeof n?n.call(null,e,t)&&i.set(c,e,{exp:r}):console.error("cacheValidate must be a Function")}catch(u){console.error(u)}s&&s(e)}}}catch(f){console.error(f)}}}),t.ajaxTransport("+*",function(t,r,n){var o=e.getCacheProxy(),a=t.ajaxCache;if(a){var i=o.getStorage(a.storageType);if(!i.isSupported())return;var c=o.genCacheKey(t,r,a.preGenCacheKey),u=i.get(c);if(u&&a.forceRefresh!==!0)return console.info("read from $ajaxCache:",u),{send:function(e,t){var r={};r.json=u,t(200,"success",r,"")},abort:function(){console.log("Aborted ajax transport for json cache.")}}}})}Object.defineProperty(t,"__esModule",{value:!0}),t.addFilterToJquery=r},function(e,t,r){var n;!function(o){"use strict";function a(e,t){var r=(65535&e)+(65535&t),n=(e>>16)+(t>>16)+(r>>16);return n<<16|65535&r}function i(e,t){return e<<t|e>>>32-t}function c(e,t,r,n,o,c){return a(i(a(a(t,e),a(n,c)),o),r)}function u(e,t,r,n,o,a,i){return c(t&r|~t&n,e,t,o,a,i)}function s(e,t,r,n,o,a,i){return c(t&n|r&~n,e,t,o,a,i)}function f(e,t,r,n,o,a,i){return c(t^r^n,e,t,o,a,i)}function l(e,t,r,n,o,a,i){return c(r^(t|~n),e,t,o,a,i)}function h(e,t){e[t>>5]|=128<<t%32,e[(t+64>>>9<<4)+14]=t;var r,n,o,i,c,h=1732584193,d=-271733879,g=-1732584194,p=271733878;for(r=0;r<e.length;r+=16)n=h,o=d,i=g,c=p,h=u(h,d,g,p,e[r],7,-680876936),p=u(p,h,d,g,e[r+1],12,-389564586),g=u(g,p,h,d,e[r+2],17,606105819),d=u(d,g,p,h,e[r+3],22,-1044525330),h=u(h,d,g,p,e[r+4],7,-176418897),p=u(p,h,d,g,e[r+5],12,1200080426),g=u(g,p,h,d,e[r+6],17,-1473231341),d=u(d,g,p,h,e[r+7],22,-45705983),h=u(h,d,g,p,e[r+8],7,1770035416),p=u(p,h,d,g,e[r+9],12,-1958414417),g=u(g,p,h,d,e[r+10],17,-42063),d=u(d,g,p,h,e[r+11],22,-1990404162),h=u(h,d,g,p,e[r+12],7,1804603682),p=u(p,h,d,g,e[r+13],12,-40341101),g=u(g,p,h,d,e[r+14],17,-1502002290),d=u(d,g,p,h,e[r+15],22,1236535329),h=s(h,d,g,p,e[r+1],5,-165796510),p=s(p,h,d,g,e[r+6],9,-1069501632),g=s(g,p,h,d,e[r+11],14,643717713),d=s(d,g,p,h,e[r],20,-373897302),h=s(h,d,g,p,e[r+5],5,-701558691),p=s(p,h,d,g,e[r+10],9,38016083),g=s(g,p,h,d,e[r+15],14,-660478335),d=s(d,g,p,h,e[r+4],20,-405537848),h=s(h,d,g,p,e[r+9],5,568446438),p=s(p,h,d,g,e[r+14],9,-1019803690),g=s(g,p,h,d,e[r+3],14,-187363961),d=s(d,g,p,h,e[r+8],20,1163531501),h=s(h,d,g,p,e[r+13],5,-1444681467),p=s(p,h,d,g,e[r+2],9,-51403784),g=s(g,p,h,d,e[r+7],14,1735328473),d=s(d,g,p,h,e[r+12],20,-1926607734),h=f(h,d,g,p,e[r+5],4,-378558),p=f(p,h,d,g,e[r+8],11,-2022574463),g=f(g,p,h,d,e[r+11],16,1839030562),d=f(d,g,p,h,e[r+14],23,-35309556),h=f(h,d,g,p,e[r+1],4,-1530992060),p=f(p,h,d,g,e[r+4],11,1272893353),g=f(g,p,h,d,e[r+7],16,-155497632),d=f(d,g,p,h,e[r+10],23,-1094730640),h=f(h,d,g,p,e[r+13],4,681279174),p=f(p,h,d,g,e[r],11,-358537222),g=f(g,p,h,d,e[r+3],16,-722521979),d=f(d,g,p,h,e[r+6],23,76029189),h=f(h,d,g,p,e[r+9],4,-640364487),p=f(p,h,d,g,e[r+12],11,-421815835),g=f(g,p,h,d,e[r+15],16,530742520),d=f(d,g,p,h,e[r+2],23,-995338651),h=l(h,d,g,p,e[r],6,-198630844),p=l(p,h,d,g,e[r+7],10,1126891415),g=l(g,p,h,d,e[r+14],15,-1416354905),d=l(d,g,p,h,e[r+5],21,-57434055),h=l(h,d,g,p,e[r+12],6,1700485571),p=l(p,h,d,g,e[r+3],10,-1894986606),g=l(g,p,h,d,e[r+10],15,-1051523),d=l(d,g,p,h,e[r+1],21,-2054922799),h=l(h,d,g,p,e[r+8],6,1873313359),p=l(p,h,d,g,e[r+15],10,-30611744),g=l(g,p,h,d,e[r+6],15,-1560198380),d=l(d,g,p,h,e[r+13],21,1309151649),h=l(h,d,g,p,e[r+4],6,-145523070),p=l(p,h,d,g,e[r+11],10,-1120210379),g=l(g,p,h,d,e[r+2],15,718787259),d=l(d,g,p,h,e[r+9],21,-343485551),h=a(h,n),d=a(d,o),g=a(g,i),p=a(p,c);return[h,d,g,p]}function d(e){var t,r="";for(t=0;t<32*e.length;t+=8)r+=String.fromCharCode(e[t>>5]>>>t%32&255);return r}function g(e){var t,r=[];for(r[(e.length>>2)-1]=void 0,t=0;t<r.length;t+=1)r[t]=0;for(t=0;t<8*e.length;t+=8)r[t>>5]|=(255&e.charCodeAt(t/8))<<t%32;return r}function p(e){return d(h(g(e),8*e.length))}function v(e,t){var r,n,o=g(e),a=[],i=[];for(a[15]=i[15]=void 0,o.length>16&&(o=h(o,8*e.length)),r=0;16>r;r+=1)a[r]=909522486^o[r],i[r]=1549556828^o[r];return n=h(a.concat(g(t)),512+8*t.length),d(h(i.concat(n),640))}function y(e){var t,r,n="0123456789abcdef",o="";for(r=0;r<e.length;r+=1)t=e.charCodeAt(r),o+=n.charAt(t>>>4&15)+n.charAt(15&t);return o}function x(e){return unescape(encodeURIComponent(e))}function m(e){return p(x(e))}function C(e){return y(m(e))}function w(e,t){return v(x(e),x(t))}function b(e,t){return y(w(e,t))}function j(e,t,r){return t?r?w(t,e):b(t,e):r?m(e):C(e)}n=function(){return j}.call(t,r,t,e),!(void 0!==n&&(e.exports=n))}(this)},function(e,t,r){var n,o;!function(a,i){n=i,o="function"==typeof n?n.call(t,r,t,e):n,!(void 0!==o&&(e.exports=o))}(this,function(){"use strict";function e(e,t){for(var r in t)e[r]=t[r];return e}function t(e){var t=!1;if(e&&e.setItem){t=!0;var r="__"+Math.round(1e7*Math.random());try{e.setItem(r,r),e.removeItem(r)}catch(n){t=!1}}return t}function r(e){var t=typeof e;return"string"===t&&window[e]instanceof Storage?window[e]:e}function n(e){return"[object Date]"===Object.prototype.toString.call(e)&&!isNaN(e.getTime())}function o(e,t){if(t=t||new Date,"number"==typeof e?e=e===1/0?l:new Date(t.getTime()+1e3*e):"string"==typeof e&&(e=new Date(e)),e&&!n(e))throw new Error("`expires` parameter cannot be converted to a valid Date instance");return e}function a(e){var t=!1;if(e)if(e.code)switch(e.code){case 22:t=!0;break;case 1014:"NS_ERROR_DOM_QUOTA_REACHED"===e.name&&(t=!0)}else-2147024882===e.number&&(t=!0);return t}function i(e,t){this.c=(new Date).getTime(),t=t||l;var r=o(t);this.e=r.getTime(),this.v=e}function c(e){return"object"!=typeof e?!1:e&&"c"in e&&"e"in e&&"v"in e?!0:!1}function u(e){var t=(new Date).getTime();return t<e.e}function s(e){return"string"!=typeof e&&(console.warn(e+" used as a key, but it is not a string."),e=String(e)),e}function f(n){var o={storage:"localStorage",exp:1/0},a=e(o,n),i=r(a.storage),c=t(i);this.isSupported=function(){return c},c?(this.storage=i,this.quotaExceedHandler=function(e,t,r){if(console.warn("Quota exceeded!"),r&&r.force===!0){var n=this.deleteAllExpires();console.warn("delete all expires CacheItem : ["+n+"] and try execute `set` method again!");try{r.force=!1,this.set(e,t,r)}catch(o){console.warn(o)}}}):e(this,d)}var l=new Date("Fri, 31 Dec 9999 23:59:59 UTC"),h={serialize:function(e){return JSON.stringify(e)},deserialize:function(e){return e&&JSON.parse(e)}},d={set:function(){},get:function(){},"delete":function(){},deleteAllExpires:function(){},clear:function(){},add:function(){},replace:function(){},touch:function(){}},g={set:function(t,r,n){if(t=s(t),n=e({force:!0},n),void 0===r)return this["delete"](t);var o=h.serialize(r),c=new i(o,n.exp);try{this.storage.setItem(t,h.serialize(c))}catch(u){a(u)?this.quotaExceedHandler(t,o,n,u):console.error(u)}return r},get:function(e){e=s(e);var t=null;try{t=h.deserialize(this.storage.getItem(e))}catch(r){return null}if(c(t)){if(u(t)){var n=t.v;return h.deserialize(n)}this["delete"](e)}return null},"delete":function(e){return e=s(e),this.storage.removeItem(e),e},deleteAllExpires:function(){for(var e=this.storage.length,t=[],r=this,n=0;e>n;n++){var o=this.storage.key(n),a=null;try{a=h.deserialize(this.storage.getItem(o))}catch(i){}if(null!==a&&void 0!==a.e){var c=(new Date).getTime();c>=a.e&&t.push(o)}}return t.forEach(function(e){r["delete"](e)}),t},clear:function(){this.storage.clear()},add:function(t,r,n){t=s(t),n=e({force:!0},n);try{var o=h.deserialize(this.storage.getItem(t));if(!c(o)||!u(o))return this.set(t,r,n),!0}catch(a){return this.set(t,r,n),!0}return!1},replace:function(e,t,r){e=s(e);var n=null;try{n=h.deserialize(this.storage.getItem(e))}catch(o){return!1}if(c(n)){if(u(n))return this.set(e,t,r),!0;this["delete"](e)}return!1},touch:function(e,t){e=s(e);var r=null;try{r=h.deserialize(this.storage.getItem(e))}catch(n){return!1}if(c(r)){if(u(r))return this.set(e,this.get(e),{exp:t}),!0;this["delete"](e)}return!1}};return f.prototype=g,f})}])});